#!/usr/bin/python

"""
This file is part of Visuse.

Copyright (C) 2010 Jose Luis Lopez Pino jllopezpino@gmail.com

Visuse is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Visuse is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Visuse.  If not, see <http://www.gnu.org/licenses/>.

"""

import urllib
import json
from classes import *
import config


class GoogleImages(Result, ImageResult):
    def __init__(self, name, url, summary, width, height, context_url, thumbnail):
        ImageResult.__init__(self, name, url, thumbnail)
        self.summary = summary
        self.width = width
        self.height = height
        self.context_url = context_url



class SearchGoogleImages(SearchModule):
	def __init__(self):
		SearchModule.__init__(self)

		
	def search(self, search_terms):
		query = urllib.urlencode({'q'   : search_terms,
									'v'   : '1.0',      # obligatory!!!
									'rsz' : 'large'})   # 8 results per query

		url = 'http://ajax.googleapis.com/ajax/services/search/images?%s' \
			% (query)
		
		file = urllib.urlopen(url).read()

		resultDictionary = json.loads(file)['responseData']['results']
		
		for i in resultDictionary:
			self.add(i)
		
		return self.resultList
	

	def add(self, entry):
		self.resultList.append(GoogleImages( \
			entry['titleNoFormatting'], \
			entry['unescapedUrl'], \
			entry['contentNoFormatting'], \
			entry['width'], \
			entry['height'], \
			entry['originalContextUrl'], \
			entry['tbUrl'] \
		))


#~ s = SearchGoogleImages()
#~ s.search("molina")
#~ print unicode(s).encode("iso-8859-2", "replace")



